// test/local-stream.js
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    config: {
      type: Object,
      value: {}
    },
  },

  /**
   * 组件的初始数据
   */
  data: {
    pusherContext: null,
    pushConfig: {}
  },

  lifetimes: {
    created() {

    },
    attached: function () {
      this.data.pusherContext = wx.createLivePusherContext();
      this.setData({
        pushConfig: {
          ...this.data.pushConfig,
          ...this.data.config
        }
      });
    },
    error(err) {
      console.log(err);
    }
  },
  pageLifetimes: {
    show() {
      //  监听组件所在页面的onShow事件, 供sdk内部监听
      this.onShow && this.onShow();
    }
  },

  /**
   * 组件的方法列表
   */
  methods: {
    start(options) { this.data.pusherContext.start(options); },
    stop(options) { this.data.pusherContext.stop(options); },
    pause(options) { this.data.pusherContext.pause(options); },
    resume(options) { this.data.pusherContext.resume(options); },
    switchCamera(options) { this.data.pusherContext.switchCamera(options); },
    snapshot(quality) { return this.data.pusherContext.snapshot(quality); },
    playBGM(url, options) { this.data.pusherContext.playBGM({url, ...options}); },
    stopBGM(options) { this.data.pusherContext.stopBGM(options); },
    pauseBGM(options) { this.data.pusherContext.pauseBGM(options); },
    resumeBGM(options) { this.data.pusherContext.resumeBGM(options); },
    setBGMVolume(volume, options) { this.data.pusherContext.setBGMVolume({volume, ...options}); },
    setMICVolume(volume, options) { this.data.pusherContext.setMICVolume({volume, ...options}); },
    startPreview(options) { this.data.pusherContext.startPreview(options); },
    stopPreview(options) { this.data.pusherContext.stopPreview(options); },
    init(config) {
      Object.assign(this.data.pushConfig, config);
      this.setData({
        pushConfig: this.data.pushConfig
      });
      console.log(this.data.pushConfig);
    },
    onStateChange(event) {},
    onNetStateChange(event) {},
    onError(event) {},
    onBGMStart(event) {},
    onBGMProcess(event) {},
    onBGMComplete(event) {},
    onAudioVolumeNotify(event) {},
    onShow() {},
  }
})
