// components/remote-stream.js
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    config: {
      type: Object,
      value: {}
    },
  },

  /**
   * 组件的初始数据
   */
  data: {
    playerId: '',
    playConfig: {}
  },

  lifetimes: {
    created() {
    },
    attached () {
      this.setData({
        playConfig: {
          ...this.data.playConfig,
          ...this.data.config
        }
      });
    },
    error(err) {
      console.log(err);
    }
  },
  pageLifetimes: {
    show() {
      //  监听组件所在页面的onShow事件, 供sdk内部监听
      this.onShow && this.onShow();
    }
  },

  /**
   * 组件的方法列表
   */
  methods: {
    play(options) { this.data.player.play(options); },
    stop(options) { this.data.player.stop(options); },
    mute(options) { this.data.player.mute(options); },
    pause(options) { this.data.player.pause(options); },
    resume(options) { this.data.player.resume(options); },
    requestFullScreen(direction, options) { this.data.player.requestFullScreen({direction, ...options}); },
    exitFullScreen(options) { this.data.player.exitFullScreen(options); },
    exitPictureInPicture(options) { this.data.player.exitPictureInPicture(options); },
    snapshot(quality) { this.data.player.snapshot(quality); },
    init(config) {
      Object.assign(this.data.playConfig, config);
      this.setData({
        playConfig: this.data.playConfig
      });
    },
    onStateChange(event) {},
    onFullScreenChange(event) {},
    onNetStateChange(event) {},
    onAudioVolumeNotify(event) {},
    onEnterPictureInPicture(event) {},
    onLeavePictureInPicture(event) {},
    onShow() {},
  }
})
